;nyquist plug-in
;version 3
;type generate
;categories "http://lv2plug.in/ns/lv2core#GeneratorPlugin"
;name "Karplus-Strong Synthesis..."
;action "Generating Music..."

;control tune "Enter notation" string "" "d3 g3 a3 b3 c4 d4 e4 d4 b3 c4 d4 e4 fs4 g4 a4 g4 e4 d4 e4 d4 b3 c4 b3 a3 g3 fs3 g3 a3 g3 fs3 d3 e3 fs3 g3 a3 b3 c4 d4 e4 d4 b3 c4 d4 e4 fs4 g4 fs4 g4 a4 b4 a4 g4 fs4 g4 fs4 e4 d4 cs4 d4 e4 fs4" 

(setf ks-class (send class :new
                  '(cnt total-cnt last-output current-output string len total-len)))

(send ks-class :answer :isnew '(pitch dur)
  '((setf len (round (/ *sound-srate* (step-to-hz pitch))))
    (setf total-len (* *sound-srate* dur))
    (setf string (snd-samples (noise (/ (step-to-hz pitch))) len))
    (setf cnt 0)
    (setf total-cnt 0)
    (setf last-output 0.0)
    (setf current-output 0.0)))

(send ks-class :answer :next '()
  '((setf current-output (aref string cnt))
    (setf (aref string cnt) (/ (+ current-output last-output) 2.0))
    (setf last-output current-output)
    (setf cnt (if (= (1- len) cnt) 0 (1+ cnt)))
    (setf total-cnt (1+ total-cnt))
    (if (= total-cnt total-len) NIL current-output)))

(defun ks (pitch dur)
  (let (obj)
    (setf obj (send ks-class :new pitch dur))
    (snd-fromobject (local-to-global 0.0) *sound-srate* obj)))

(defun string-to-list (string)
  (read (make-string-input-stream (format nil "(~a)" string))))
  

(setf tune (string-to-list tune))

(abs-env (seq (seqrep (i (length tune))(ks (eval (nth i tune)) 0.2))(ks g4 1)))